<?

/* inizializzazione dei parametri comuni */
include("./config.php3");


/* pasticcio per il logo... */
$Logo	= "./images/$Logo";

/* inserisco le funzioni comuni */
include("./common.php3");

/* Utilizziamo i cookie per nomi e prezzi delle pietanze... */
if ( (!IsSet($nomep)) || (!IsSet($prezzop)) ) {
	InizializzaPietanze("");
}
Reset($nomep);
while ($i < Count($nomep)) {
	$chiave = Key($nomep);
	SetCookie("nomep[$chiave]",$nomep[$chiave],time()+1);
	SetCookie("prezzop[$chiave]",$prezzop[$chiave],time()+1);
	Next($nomep);
	$i++;
}?>

<HTML>

<HEAD>
<TITLE>Gestione Cassa</TITLE>
</HEAD>

<BODY>


<?

/*	*****************************
 *	FUNZIONI DI UTILITA` GENERALE
 *	*****************************/

/* quelle in comune le carico da qui... */
/* Le carico invece sopra, sono costretto da SetCookie()... */


/* Controllo che l'ID passato sia esistente e buono...
   questa operazione viene eseguita una volta per tutte e solo se
   effettivamente passo un ID ;) */
function ControllaID($ID) {

global $DBName, $SQLHost;

$esiste = false;
if ( (IsSet($ID)) && ($ID != "") ) {

	/* connessione al server */
	$DBConn = pg_Connect($SQLHost, "", "", "", $DBName);

	/* seleziono l'identificativo che mi e` stato passato */
	$result = pg_Exec($DBConn, "SELECT IDVolontario FROM Volontario WHERE (IDVolontario='$ID' AND Servizio='C')");
	if ( ($result) && (pg_NumRows($result) == 1) )
		$esiste = true;

	pg_Close($DBConn);
}

return($esiste);

}




/*	*************************************
 *	FUNZIONI DI INSERIMENTO/CANCELLAZIONE
 *	*************************************/

/* Elimino un ordine */
function Cancella($NO,$D) {

global $DBConn;
global $IDCorrente;


/* sanity check */
if ( $IDCorrente == "" )
	return(false);

/* elimino il record incriminato
   non eseguo una reale cancellazione, solo lo marco cancellato */
$result = pg_Exec($DBConn, "UPDATE Ordine SET Stato='D' WHERE (Nordine='$NO' AND DataOrdine='$D')");

return($result);

}


/* inserisco un record... */
function Inserisci($NO, $D, $TS, $QTA, $NC) {

global $DBConn;
global $IDCorrente;


/* sanity check */
if ( $IDCorrente == "" ) {
	return(false);
}

/* controllino iniziale... se il nome del cliente non e` nullo,
   l'ordine e` da considerarsi da asporto... */
if ($NC != "") {
	$S = "X";
} else {
	$S = "I";
}

/* converto lo UNIX timestamp nel formato SQL... */
$MTS = Date("Y-m-d H:i:s", $TS);

/* faccio una lock per avere un aggiornamento coerente... */
$commit = pg_Exec($DBConn, "BEGIN TRANSACTION");

/* eseguo l'inserimento principale... */
if ( ($commit) && (!pg_Exec($DBConn, "INSERT INTO Ordine VALUES ('$NO', '$D', '$S')")) )
	$commit = false;

/* ...e quindi aggiorno la storia... */
if ( ($commit) && (!pg_Exec($DBConn, "INSERT INTO Storia VALUES ('$NO', '$D', '$IDCorrente', '$MTS')")) )
	$commit = false;

/* se e` da asporto devo anche aggiornare quello... */
if ( ($commit) && ($S == "X") && (!pg_Exec($DBConn, "INSERT INTO Asporto VALUES ('$NO', '$D', '$NC')")) )
	$commit = false;

/* ...e quindi inserisco i componenti dell'ordine */
Reset($QTA);
$i = 0;
while ( ($i < Count($QTA)) && ($commit) ) {
	$key = Key($QTA);
	$q = $QTA[$key];
	if ( ($commit) && (!pg_Exec($DBConn, "INSERT INTO Composizione VALUES ('$NO', '$D', '$key', '$QTA[$key]')")) )
		$commit = false;
	Next($QTA);
	$i++;
}

/* sblocco le tabelle, ed effettuo la reale modifica con commit/rollback... */
if (!$commit)
	pg_Exec($DBConn, "ROLLBACK");
else
	pg_Exec($DBConn, "COMMIT");

return($commit);

}



/*	*****************************************************
 *	FUNZIONI PER LA GESTIONE DELLA VISUALIZZAZIONE/STAMPA
 *	*****************************************************/

/* quelle in comune le carico da qui... */
include("./stampa.php3");
include("./visual.php3");



/* Stampa la miniform per la selezione di un ordine */
function StampaFormSelezioneO($URL) {

global $IDCorrente;


/* sanity check */
if ( $IDCorrente == "" ) {
	return(-1);
}

$d = Date("Y-m-d")?>

<BF>Numero&nbsp;&nbsp;Data</BF><BR>
<FORM ACTION="<?echo $URL?>" METHOD="post">
<INPUT TYPE=text NAME="NO" SIZE=5 MAXLENGTH=5>
&nbsp;<INPUT TYPE=text NAME="D" SIZE=10 MAXLENGTH=10 VALUE="<?echo $d?>">
<INPUT TYPE=submit VALUE="Ok">
</FORM>

<?return(0);

}


/* Stampo una form falsa (tutti i parametri hidden) per passare i dati
   col metodo post... */
function StampaFormFalsa($NO, $D, $TS, $IDV, $NC, $QTA, $Label, $URL) {?>


<FORM ACTION="<?echo $URL?>"
	METHOD="post">
<INPUT NAME="NO" TYPE="hidden" VALUE="<?echo $NO?>">
<INPUT NAME="D" TYPE="hidden" VALUE="<?echo $D?>">
<?if ($TS != "") {?>
	<INPUT NAME="TS" TYPE="hidden" VALUE="<?echo $TS?>">
<?}
if ($NC != "") {?>
	<INPUT NAME="NC" TYPE="hidden" VALUE="<?echo $NC?>">
<?}
if ($IDV != "") {?>
	<INPUT NAME="IDV" TYPE="hidden" VALUE="<?echo $IDV?>">
<?}

if (!Empty($QTA)) {
	$i = 0;
	Reset($QTA);
	while ( $i < Count($QTA) ) {
		$key = Key($QTA);?>
		<INPUT NAME="<?echo $key?>" TYPE="hidden"
			VALUE="<?echo $QTA[$key]?>">
		<?$i++;
		Next($QTA);
	}
}?>

<INPUT TYPE=submit VALUE="<?echo $Label?>">
</FORM>

<?return(true);

}




/*	********************
 *	PROGRAMMA PRINCIPALE
 *	********************/

/* Header standard */
include("./head.php3");


/* dei default sani... */
if ( $argv[0] == "" ) {
        $argv[0] = "sceltaID";
}

if ( (!ControllaID($IDCorrente)) && ($argv[0] != "real_choose") ) {
	$argv[0] = "sceltaID";
	$ID_CGI = "";
	$BackLink = "";
} else {
	$ID_CGI = "&IDCorrente=$IDCorrente";
	$BackLink = "$PHP_SELF?menu+$ID_CGI";
}



switch ($argv[0]) {

/* indice delle operazioni, non e` attivo di default */
case "menu":?>

	<CENTER>
	<B><FONT SIZE+1>Menu Principale</FONT></B><P>

	<TABLE WIDTH=75%><TR>
	<TD ALIGN=left><A HREF="<?echo $PHP_SELF?>?inserisci+<?echo $ID_CGI?>">
		Inserimento Ordini</A></TD>
	<TD ALIGN=right><A HREF="<?echo $PHP_SELF?>?ristampa+<?echo $ID_CGI?>">
		Ristampa Ordini</A></TD>
	</TR>
	<TR>
	<TD ALIGN=left><A HREF="<?echo $PHP_SELF?>?sceltaID">
		Menu scelta nuovo utente</A></TD>
	<TD ALIGN=right><A HREF="<?echo $PHP_SELF?>?cancella+<?echo $ID_CGI?>">
		Cancellazione Ordini</A></TD>
	</TR></TABLE>
	</CENTER>

	<?/* non mi piacciono i link tautologici... */
	$BackLink = "";

	break;

/*	Selezione ID Volontario */
case "sceltaID":

	/* mi connetto... */
	$DBConn = pg_Connect($SQLHost, "", "", "", $DBName);?>

	<CENTER>
	<B><FONT SIZE=+2>Scegli il tuo identificativo dalla lista</FONT><BR>
	Tutti gli ordini verranno inseriti con l'identificativo prescelto<BR>
	In ogni momento puoi ottenere l'identificativo corrente guardando in
	basso a destra</B><P>
	</CENTER>

	<?/* stampo la form di selezione... */
	if (!StampaFormSelezione("$PHP_SELF?real_choose", "SELECT IDVolontario,Nome,Cognome FROM Volontario WHERE (Servizio = 'C')", idvolontario, nome, cognome)) {
		echo "Problema facendo SELECT<P>";
		pg_ErrorMessage($DBConn);
	}

	/* chiudo e esco... */
	pg_close($DBConn);
	break;


/*	Modalita` inserimento, prima parte */
case "inserisci":

	echo "<BF>Inserimento di un Ordine</BF><P>";

	/* siccome potrebbe essere un ``ritorno'', devo anche costruire
	   l'array delle variabili passate... mi preoccupo del
	   separatore (non l'ho messo nella form ma e` in nomep), e mi
	   preoccupo che non girino stringhe e/o numeri zero...
	   Ripeto questo codice piu` volte, ma non e` possibil farne una
	   funzione... ;((( */
	$i = 0;
	Reset($nomep);
	while ($i < Count($nomep)) {
		$chiave = Key($nomep);
		if ( ($nomep[$chiave] != "separatore") && (SetType($$chiave, "integer")) && ($$chiave != 0) )
			$QTA[$chiave] = $$chiave;
		Next($nomep);
		$i++;
	}

	/* Nordine e Data sono sicuramente nulli, sto inserendo!!! */
	StampaFormInserimento("", "", $QTA, $NC, "$PHP_SELF?inserisci_2+$ID_CGI");

	break;


/*      Modalita` inserimento, seconda parte */
case "inserisci_2":

	/* devo estrarre l'array da passare...
	   contemporaneamente calcolo il totale delle portate, e se
	   zero evito di stampare... */
	$i = 0;
	Reset($nomep);
	$sum = 0;
	while ($i < Count($nomep)) {
		$chiave = Key($nomep);
		if ( ($nomep[$chiave] != "separatore") && (SetType($$chiave, "integer")) && ($$chiave != 0) ) {
			$QTA[$chiave] = $$chiave;
			$sum = $sum + $$chiave;
		}
		Next($nomep);
		$i++;
	}

	StampaOrdine("", "", "", "", $QTA, $NC, "C")?>

	<TABLE><TR>
	<TD>
	<?if ( $sum > 0 ) {
		StampaFormFalsa("", "", "", "", $NC, $QTA, "Stampa", "$PHP_SELF?real_insert+$ID_CGI");
	}?></TD>
	<TD>	<?StampaFormFalsa("", "", "", "", $NC, $QTA, "Correggi", "$PHP_SELF?inserisci+$ID_CGI");?></TD>
	</TR></TABLE>

	<?break;


/*	Cancellazione prima parte */
case "cancella":?>

	<P ALIGN=center><B>
	Inserisci Numero e data del'ordine da cancellare
	</B></P>

	<?
	StampaFormSelezioneO("$PHP_SELF?cancella_2+$ID_CGI");
	break;

/*	Cancellazione seconda parte */
case "cancella_2":

	/* mi connetto... */
	$DBConn = pg_Connect($SQLHost, "", "", "", $DBName);

	if (!InizializzaOrdine($NO, $D, "C")) {?>

		Stai cercando di cancellare un ordine inesistente o non
		cancellabile.<P>

		Non sono cancellabili tutti gli ordini che sono gia`
		passati per le cameriere o per la cassa.<P>

		Siccome il pezzo di carta e` sicuramente gia` passato in
		cucina, il fatto che si ripresenti a te vuol dire che
		qualcosa di grave sta accadendo, in particolare:<P>

		<UL>
		<LI>	ti stanno cercando di fregare
		<LI>	il sistema non funziona.
		</UL><P>

		Scegli a seconda della quantita` di fiducia che poni nel
		popolo dei programmatori o in te stesso... ;-)))<P>

	<?} else {?>

		<P ALIGN=center><B>
		Sei sicuro di voler cancellare questo Ordine?
		</B></P>

		<?/* stampo l'ordine... */
		StampaOrdine($NO, $D, $TS, "$IDV", $QTA, "$NC", "C")?>

		<?StampaFormFalsa($NO, $D, "", "", "", "", "Si", "$PHP_SELF?real_delete+$ID_CGI");?>
		<A HREF="<?echo $PHP_SELF?>?menu+<?echo $ID_CGI?>">
			No, ritorna all'inizio</A>
	<?}
	/* chiudo e esco... */
	pg_close($DBConn);
	break;


case "ristampa":

	echo "<B>Inserisci numero e data dell'ordine da ristampare...</B><P>";

	StampaFormSelezioneO("$PHP_SELF?ristampa_2+$ID_CGI");

	break;


case "ristampa_2": ?>

	<CENTER><B>
	Sei sicuro di voler ristampare l'ordine <?echo $NO?> del
	<?echo $D?>?!<BR>
	Sincerati ASSOLUTAMENTE che non ci siano altre copie dell'ordine
	che stai ristampando in giro...<P>
	</B></CENTER>

	<?/* mi connetto... */
	$DBConn = pg_Connect($SQLHost, "", "", "", $DBName);

	if (!InizializzaOrdine($NO, $D, "C")) {?>

		Stai cercando di stampare un ordine inesistente o non
		ristampabile.<P>

		Non sono ristampabili tutti gli ordini che sono gia`
		passati per le cameriere o per la cucina.<P>

	<?} else {

		/* stampo l'ordine... */
		StampaOrdine($NO, $D, $TS, $IDV, $QTA, "$NC", "C");

		StampaFormFalsa($NO, $D, $TS, $IDV, "$NC", $QTA, "Si", "$PHP_SELF?real_print+$ID_CGI");?>

		<A HREF="<?echo $PHP_SELF?>?menu+<?echo $ID_CGI?>">
			No, ritorna al Menu</A>
		<P>

	<?}
	/* chiudo e esco... */
	pg_close($DBConn);
	break;


/*	Reale cancellazione dei dati */
case "real_delete":

	/* mi connetto... */
	$DBConn = pg_Connect($SQLHost, "", "", "", $DBName);

	/* eseguo la cancellazione... */
	if (!Cancella($NO,$D)) {
		echo "<BR>Errore cancellando il dato!<P>";
		pg_ErrorMessage();
	}

	echo "<BR>Cancellazione effettuata con successo<P>";

	/* chiudo e esco... */
	pg_close($DBConn);
	break;


/*	Reale inserimento dei dati */
case "real_insert":

	/* mi connetto... */
	$DBConn = pg_Connect($SQLHost, "", "", "", $DBName);

	/* devo estrarre l'array da passare... */
	$i = 0;
	Reset($nomep);
	while ($i < Count($nomep)):
		$chiave = Key($nomep);
		if ( ($nomep[$chiave] != "separatore")  && (SetType($$chiave, "integer")) && ($$chiave != 0) )
			$QTA[$chiave] = $$chiave;
		Next($nomep);
		$i++;
	endwhile;

	/* Prelevo un numero d'ordine e un timestamp, e da questo una
	   data (si, sono maniaco... ;) */
	$NO = GetNord();
	$TS = Date("U");
	$D = Date("Y-m-d",$TS);

	/* eseguo l'inserimento... */
	if ( ($NO > 0) && (Inserisci($NO, $D, $TS, $QTA, $NC)) ) {

		/* stampo l'ordine sulla stampante... */
		if ( !LPRCassa($NO, $D, $TS, $IDCorrente, $QTA, $NC) )
			echo "Errore mandando l'ordine $NO del $D in stampa!<BR>";
		else
			echo "Ordine Numero $NO del $D inserito e in stampa.<P>";
		?>

		<A HREF="<?echo $PHP_SELF?>?inserisci+<?echo $ID_CGI?>">
			Nuovo inserimento</A><P>

	<?} else {
		echo "<BR>Errore inserendo i dati!<BR>";
		pg_ErrorMessage($DBConn);
		echo "<P>";

		/* devo avere la possibilita` di ``recuperare'' un
		   inserimento andato a male, mannaggia!!! */
		StampaFormFalsa("", "", "", "", $NC, $QTA, "Riprova", "$PHP_SELF?real_insert+$ID_CGI");
	}

	/* chiudo e esco... */
	pg_close($DBConn);
	break;


/* seleziono realmente l'identificativo riempiendo per la prima volta
   la variabile IDCorrente */
case "real_choose":

	/* semplicemente strippo e assegno... */
	$IDCorrente = strtok($Selezione, " ");
	$ID_CGI = "&IDCorrente=$IDCorrente"?>

	<A HREF="<?echo $PHP_SELF?>?inserisci+<?echo $ID_CGI?>">
		Buon lavoro!</A><P>

	<?

	break;


/* Effettiva (ri)stampa dell'ordine */
case "real_print":

	/* mi connetto... */
	$DBConn = pg_Connect($SQLHost, "", "", "", $DBName);

	/* devo estrarre l'array da passare... */
	$i = 0;
	Reset($nomep);
	while ($i < Count($nomep)):
		$chiave = Key($nomep);
		if ( ($nomep[$chiave] != "separatore")  && (SetType($$chiave, "integer")) && ($$chiave != 0) )
			$QTA[$chiave] = $$chiave;
		Next($nomep);
		$i++;
	endwhile;

	/* stampo l'ordine sulla stampante... */
	if (!LPRCassa($NO, $D, $TS, $IDCorrente, $QTA, $NC))
		echo "Errore mandando l'ordine $NO del $D in stampa!<BR>";
	else
		echo "Ordine Numero $NO del $D in stampa.<P>";

	/* chiudo e esco... */
	pg_close($DBConn);
	break;

}

/* Footer standard */
include("./tail.php3");?>

</BODY>
</HTML>
