<?
/*	*****************************
 *	FUNZIONI DI UTILITA` GENERALE
 *	   (usate un po' da tutti)
 *	*****************************/


/*	*************************
 * 	FUNZIONI VARIE (utilita`)
 *	*************************/

/* produce X &nbsp; in uscita... */
function Nbsp($X) {

$i = 0;
while ($i < $X) {
	echo "&nbsp;";
	$i++;
}

}


/* produce X puntini in uscita... */
function Puntini($X) {

$i = 0;
while ($i < $X) {
	echo "_";
	$i++;
}

}


/* mi "puntina" i numeri di modo che sembrino valute... ;))) */
function ConvertiValuta($s) {

$j = 3;
$len = strlen($s);
$ss = "";
while ($j < $len ) {
	$ss = sprintf(".%s%s", substr($s, ($len-$j), 3), $ss);
	$j = $j + 3;
}
$ss = sprintf("%s%s", substr($s, 0, ($len - $j + 3)), $ss);

return($ss);

}

/* Converto il formato di data di PostGreSQL a uno UNIX_TIMESTAMP */
function DateToStamp($date) {

/* estraggo con le regex i campi */

if ( ereg( "([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})", $date, $regs ) )
	$time = mktime($regs[4],$regs[5],$regs[6],$regs[2],$regs[3],$regs[1]);
else
	$time = 0;

return($time);

}


/*	****************************************************
 *	FUNZIONI DI INIZIALIZZAZIONE e/o
 *	VISUALIZZAZIONE COMUNI E NON DIPENDENTI (table/text)
 *	****************************************************/

/* inizializzo gli array associativi per la gestione dei piatti
 */
function InizializzaPietanze($T) {

global $DBName, $Spazi;
global $nomep, $prezzop;


/* Apro la connessione */
$DBConn = pg_Connect($SQLHost, "", "", "", $DBName);

/* diamoci da fare ad usare tutte le features piu' oscure di php, e
quindi di perl; faccio ora un array associativo che uso per ricopiare i
nomi delle variabili e in mille altre occasioni...
Quindi lo faccio qui per non rifarlo ogni volta... */

/* prendo la lista delle pietanze ordinate per tipo, devo separare
   ordini di tipo diverso... */
if ( $T == "" )
	$QUERY = "SELECT IDPiatto,NomePiatto,Prezzo,Tipo,Ord FROM Piatto ORDER BY Ord";
else
	$QUERY = "SELECT IDPiatto,NomePiatto,Prezzo,Tipo,Ord FROM Piatto WHERE (Tipo = '$T') ORDER BY Ord";
$result = pg_Exec($DBConn, $QUERY);
if (!$result)
	return($result);

/* ...e costruisco due array associativi indicizzato per IDPiatto che mi
   servira` in seguito per molte cose... */
$i = 0;
$old = pg_Result($result,0,"tipo");
while ($i < pg_NumRows($result)) {
	$new = pg_Result($result,$i,"tipo");
	if ( $new != $old ) {
		$key = "$i";
		$nomep[$key] = "separatore";
		$prezzop[$key] = $Spazi;
	} else {
		$key = pg_Result($result,$i,"idpiatto");
		$nomep[$key] = pg_Result($result,$i,"nomepiatto");
		$prezzop[$key] = pg_Result($result,$i,"prezzo");
		$i++;
	}
	$old = $new;
}

pg_Close($DBConn);
return($result);

} // InizializzaPietanze


/* riempio le varie variabili con le informazioni tratte dal database,
   serve per la conferma nelle verie cancellazioni, abilitazioni e
   ristampe
 */
function InizializzaOrdine($NO, $D, $T) {

global $DBConn;
global $QTA,$NC,$IDV,$TS;


/* funziona meglio cosi'... */
if ($QTA == "") {
	UnSet($QTA);
}

/* complico un po' la query per fare piu' cose nella stessa
   connessione e con la stessa funzione... */
switch ($T) {

case "C":
	$COND = "(Stato='X' OR Stato='I')";
	break;
case "A":
	$COND = "Stato='I'";
	break;
case "V":
	$COND = "(Stato='X' OR Stato='A') AND Tipo = 'C'";
	break;
default:
	$COND = "(1 = 1)";
}
$QUERY = "SELECT Ordine.Nordine,Ordine.DataOrdine,Stato,IDVolontario,Tstamp,Composizione.IDPiatto,Qta FROM Ordine,Storia,Composizione WHERE ( (Ordine.Nordine = $NO) AND (Ordine.DataOrdine = '$D') AND $COND AND (Ordine.Nordine = Storia.Nordine) AND (Ordine.DataOrdine = Storia.DataOrdine) AND (Ordine.Nordine = Composizione.Nordine) AND (Ordine.DataOrdine = Composizione.DataOrdine) )";
$result = pg_Exec($DBConn, $QUERY);
if (!$result)
	return($result);
$rows = pg_NumRows($result);
if ($rows == 0)
	return(false);

$S = pg_Result($result,0,"stato");
$IDV = pg_Result($result,0,"idvolontario");
$TS = DateToStamp(pg_Result($result,0,"tstamp"));

$i = 0;
while ( $i < $rows ) {
	$key = pg_Result($result,$i,"idpiatto");
	$QTA[$key] = IntVal(pg_Result($result,$i,"qta"));
	$i++;
}

/* se lo stato e` X devo prelevare il nome del cliente... */
$NC = "";
if ( ($T != "A") && ($S == "X") ) {
	$result = pg_Exec($DBConn, "SELECT NomeCliente FROM Asporto WHERE (Nordine = $NO AND DataOrdine = '$D')");
	if (!$result)
		return($result);
	if ( pg_NumRows($result) > 0)
		$NC = pg_Result($result,0,"nomecliente");
	else
		return(false);
}

return(true);

}



/* Determino un numero progressivo...
 */
function GetNord() {

global $DBConn;

/* Cosa strana... PG sembra non essere atomico negli inserimenti in una
   singola tabella, per quale losco motivo non si sa... provo ad usare
   COMMIT/ROLLBACK ma la cosa mi puzza... */

pg_Exec($DBConn, "BEGIN TRANSACTION");
$result = false;
while (!$result) {

	/* Estraggo l'ultimo, se non riesco a fare manco questo esco
	   subito... */
	$result = pg_Exec($DBConn, "SELECT MAX(Numero) AS Max FROM Progressivo");
	if (!$result) {
		pg_Exec($DBConn, "ROLLBACK");
		return(-1);
	}

	/* prelevo il numero da utilizzare... */
	$N = pg_Result($result,0,"max");

	/* tento di inserire il successivo... l'operazione e` atomica e
	   quindi non mi serve assolutamente fare locks... (almeno lo
	   credevo...) */
	$N++;
	$result = pg_Exec($DBConn, "INSERT INTO Progressivo VALUES ('$N')");

}

/* chiudo, salvo e ritorno... */
pg_Exec($DBConn, "COMMIT");
return($N);

}


/* Stampa la miniform con il rolldown di selezione...
 * Ritorna ad $URL la variabile ``Selezione'' che contiene quanto
 * selezionato
 */
function StampaFormSelezione($URL, $QUERY, $a, $b, $c) {

global $DBConn;


/* seleziono i nominativi... */
$result = pg_Exec($DBConn, $QUERY);
if ($result) {?>

	<FORM ACTION="<?echo $URL?>" METHOD="post">
	<SELECT NAME="Selezione" SIZE=10>

	<?$i = 0;
	$record = pg_NumRows($result);
	while ( $i < $record ) {
		$value = pg_Fetch_Array($result,$i);
		echo "<OPTION>$value[$a] $value[$b] $value[$c]</OPTION>";
		$i++;
	}?>

	</SELECT>
	<INPUT TYPE=submit VALUE="Ok">
	</FORM><P>

<?}

return($result);

}

/* FINE */?>