<?
/*	******************
 *	FUNZIONI DI STAMPA
 *	(sono qui perche` sono le meno portabili... ;((( )
 *	******************
 *
 * questo pezzo di LinuxSagra e` quello che sicuramente dovrete andare
 * a modificare; quindi e` quello che ho cercato di commentare meglio.
 */


/* Stampo un ordine su carta, facendo un pipe a un comando
   Questa funzione e` da intendersi d'uso in cassa, e quindi
   l'attenzione e` posta sul fattore ``economico''.
   Viene usata per stampa e ristampa degli ordini, nonche` per la
   stampa dei totali a fine serata.

   rende disponibili le variabili:

   $NO, $D:	numero e data dell'ordine
   $TS:		timestamp di inserimento (in formato UNIX)
   $IDV:	ID del volontario che ha effettuato l'inserimento
   $QTA:	array delle quantita` delle portate, array associativo
		indicizzato per l'ID del piatto
   $NC:		nome cliente (se ordine da asporto, altrimenti "")

   $nomep, $prezzop:	array associativi che contengono i nomi e i
		prezzi delle pietanze, indicizzati per ID piatto
		ATTENZIONE che in corrispondenza di $nomep[$key] ==
		"separatore", prezzop[$key] rappresenta il numero di
		spazi da lasciare per separare i tipi di ordine.
   $Titolo, $SottoTitolo:	totolo e sototitolo della sagra
   $LPRCommand: array associativo indicizzato per tipo di servizio che
		contiene il comando di stampa. */

function LPRCassaEsempio($NO, $D, $TS, $IDV, $QTA, $NC) {

global $nomep, $prezzop;
global $Titolo, $SottoTitolo, $LPRCommand;


/* calcolo l'ora dal timestamp... */
$O = Date("H:i:s",$TS);
$D = sprintf("%s/%s/%s", substr($D,8,2), substr($D,5,2), substr($D,0,4));

/* apriamo la pipe... */
$pp = popen($LPRCommand["C"], "w");
if ( $pp < 0 ) {
	return(-1);
}

/* uno header carino... */
fputs($pp, "\n          $Titolo\n");
fputs($pp, "          $SottoTitolo\n\n\n");

/* un po' di informazioni... */
fputs($pp, "Ordine $NO del $D\n");
if ($NC != "") {
	fputs($pp, "       da Asporto: $NC\n");
}
fputs($pp, "Inserito da $IDV alle $O\n\n");

/* stampo l'ordine vero e proprio... */
fputs($pp, "Portata               Qta   Importo\n");
fputs($pp, "-----------------------------------\n");
$i = 0;
$sum = 0;
$tot = 0;
Reset($nomep);
while ($i < Count($nomep)) {
	$key = Key($nomep);
	/* tra i nomi dei piatti c'e` un nome falso, ``separatore'',
	   che serve... a forzare separazioni nell'output! */
	if ( $nomep[$key] == "separatore" ) {
		if ( $NC == "" ) {
			$j = 0;
		} else {
			$j = 1;
		}
		while ($j < $prezzop[$key] ) {
			fputs($pp, "\n");
			$j++;
		}
		fputs($pp, "Ordine $NO del $D\n");
		fputs($pp, "Inserito da $IDV alle $O\n\n");
	} else {
		fputs($pp, "$nomep[$key] ");
		if ($QTA[$key] == "") {
			fputs($pp, "\n");
		} else {
			$j = 0;
			while ( $j < (20 - strlen($nomep[$key])) ) {
				fputs($pp, ".");
				$j++;
			}
			fputs($pp, " $QTA[$key]");
			$sum = $QTA[$key]*$prezzop[$key];
			$j = 3;
			$len = strlen($sum);
			$sums = "";
			while ($j < $len ) {
				$sums = $sums + "." + substr($sum, $len-$j, 3);
				$j = $j + 3;
			}
			$sums = substr($sum, 0, ($len - $j + 3)) + $sums;
			$j = 0;
			while ( $j < (5 + 3 - strlen($QTA[$key]) + (4-strlen($sums))) ) {
				fputs($pp,  " ");
				$j++;
			}
			fputs($pp, "$sums\n");
			$tot = $tot + $sum;
		}
	}
	$i++;
	Next($nomep);
}
fputs($pp, "-----------------------------------\n");
fputs($pp, "Totale:");


/* formatto e stampo il totale */
$j = 3;
$len = strlen($tot);
$tots = "";
while ($j < $len ) {
	$tots = $tots + "." + substr($tot, $len-$j, 3);
	$j = $j + 3;
}
$tots = substr($tot, 0, ($len - $j +3)) + $tots;
$j = 0;
while ( $j < (25 + 2 - strlen($tots)) ) {
	fputs($pp, " ");
	$j++;
}
fputs($pp, "$tots");

/* sparo il foglio... ma guarda te se mi tocca usare il codice
   esadecimale di FF... */
fputs($pp, "\x0C");

/* chiudo la pipe... */
pclose($pp);

return(true);

}


/* quella che realmente ho usato, tarata sul biglietto prestampato
   solitamente usato e con una Canon BJ-200ex */
function LPRCassa($NO, $D, $TS, $IDV, $QTA, $NC) {

global $nomep, $prezzop;
global $Titolo, $SottoTitolo, $LPRCommand;


/* calcolo l'ora dal timestamp... */
$O = Date("H:i:s",$TS);
$D = sprintf("%s/%s/%s", substr($D,8,2), substr($D,5,2), substr($D,2,2));

/* apriamo la pipe... */
$pp = popen($LPRCommand["C"], "w");
if ( $pp < 0 ) {
	return(-1);
}

/* uffi... devo fare i conti PRIMA di stampare le righe... */
$i = 0;
$tot = 0;
Reset($nomep);
while ($i < Count($nomep)) {
	$key = Key($nomep);
	/* tra i nomi dei piatti c'e` un nome falso, ``separatore'',
	   che serve... a forzare separazioni nell'output! */
	if ( ($nomep[$key] != "separatore") && ($QTA[$key] != "") ) {
		$tot = $tot + $QTA[$key]*$prezzop[$key];
	}
	$i++;
	Next($nomep);
}
$tots = ConvertiValuta($tot);

/* stringa che contiene numero d'ordine e data, e stringa che contiene
   ID e tempo di inserimento... se sono nulle, allora e` la stampa di
   un totale... */

if ( ($NO != "") && ($D != "") ) {
	$S1 = "$NO $D";
	$S2 = "($O $IDV)";
} else {
	$S1 = "";
	$S2 = "";
}

/* Stampo su una Canon BJ-200ex, devo per forza pasticciare con i
   comandi di stampa per ottenere un output decente... */

/* imposto e attivo l'interlinea a 2/8 di pollice, qualcosina in
   piu'... uffa, 18/72 e` poco e 19/72 e` troppo... ;((( */
$passo = 12;
$cmdpasso[11] = "\x11";
$cmdpasso[12] = "\x12";
$cmdpasso[13] = "\x13";
fputs($pp, "\x1BA");
fputs($pp, $cmdpasso[$passo]);
fputs($pp, "\x1B2");
/* 'sta maledetta mi va in alta qualita`, imposto il font Bozza a 12
    CPI */
fputs($pp, "\x1BI");
fputs($pp, "\x0C");

/* salto 3 righe */
fputs($pp, "\n\r\n\r\n\r");

/* e tre a 11 di passo... */
fputs($pp, "\x1BA");
fputs($pp, $cmdpasso[11]);
fputs($pp, "\x1B2");
fputs($pp, "\n\r\n\r\n\r");


/* stampo il totale, allineato al margine di 37 caratteri */
$j = 0;
while ( $j < (37 - strlen($tots)) ) {
	fputs($pp, " ");
	$j++;
}
fputs($pp, "$tots\n\r");

/* e poi, allineate a dx e sn rispettivamente,numero d'ordine e le
   informazioni per il cliente... */
/* metto il passo a 13 */
$passo = 13;
fputs($pp, "\x1BA");
fputs($pp, $cmdpasso[$passo]);
fputs($pp, "\x1B2");
fputs($pp, "\n\r        $S1");
$j = 0;
while ( $j < (37 - strlen($S1) - strlen($S2) - 8) ) {
	fputs($pp, " ");
	$j++;
}
fputs($pp, "$S2\n\r");


/* ristampo il numero d'ordine, questa volta all'inizio... ;))) */
/* Rimetto il passo a 11 */
$passo = 11;
fputs($pp, "\x1BA");
fputs($pp, $cmdpasso[$passo]);
fputs($pp, "\x1B2");

fputs($pp, "$S1");
$j = 0;
while ( $j < (37 - strlen($S1) - strlen($S2)) ) {
	fputs($pp, " ");
	$j++;
}
fputs($pp, "$S2\n\r\n\r\n\r");


/* bene, sono pronto a stampare effettivamente l'ordine... */
$i = 0;
$sum = 0;
Reset($nomep);
while ($i < Count($nomep)) {
	$key = Key($nomep);
	/* tra i nomi dei piatti c'e` un nome falso, ``separatore'',
	   che serve... a forzare separazioni nell'output! */
	if ( $nomep[$key] == "separatore" ) {

		/* allungo un pelo il passo... */
		fputs($pp, "\x1BA");
		fputs($pp, "\x13");
		fputs($pp, "\x1B2");
		$j = 0;
		while ($j < ($prezzop[$key] - 2) ) {
			fputs($pp, "\n\r");
			$j++;
		}
		/* devo risettarle il passo... */
		fputs($pp, "\n\r");
		fputs($pp, "\x1BA");
		fputs($pp, $cmdpasso[$passo]);
		fputs($pp, "\x1B2");
	} else {
		if ($QTA[$key] == "") {
			fputs($pp, "\n\r");
		} else {
			if ( $key == "PR" ) { /* Porchetta!!! */
				fputs($pp, "  Porchetta     L. 5000");
				$salto = 4;
			} else if ( $key == "PN") { /* Panino!!! */
				fputs($pp, "  Panino        L. 5000");
				$salto = 4;
			} else
				$salto = 27;
			$j = 0;
			while ( $j < ($salto - strlen($QTA[$key])) ) {
				fputs($pp, " ");
				$j++;
			}
			fputs($pp, "$QTA[$key]");
			$sum = $QTA[$key]*$prezzop[$key];
			$sums = ConvertiValuta($sum);
			$j = 0;
			while ( $j < (10 - strlen($sums)) ) {
				fputs($pp,  " ");
				$j++;
			}
			fputs($pp, "$sums\n\r");
		}
	}
	/* ma guarda che porcate che mi tocca fare... */
	if ( ($i % 3) == 0 ) {
		if ($passo == 12) {
			$passo = 13;
		} else {
			$passo = 12;
		}
		fputs($pp, "\x1BA");
		fputs($pp, $cmdpasso[$passo]);
		fputs($pp, "\x1B2");
		fputs($pp, "\x1BI");
		fputs($pp, "\x0C");
	}
	$i++;
	Next($nomep);
}

/* scrivo l'ultima riga, numero d'ordine (ancora!) e totale... */
fputs($pp, "\n\r$S1");
$j = 0;
while ( $j < (37 - strlen($tots) - strlen($S1)) ) {
	fputs($pp, " ");
	$j++;
}
fputs($pp, "$tots");

/* Risetto il passo a 13 */
fputs($pp, "\x1BA");
fputs($pp, $cmdpasso[13]);
fputs($pp, "\x1B2");
fputs($pp, "\n\r");

/* e ora un po' di informazioni aggiuntive... */
if ( $NC != "" )
	fputs($pp, "$NC");
else
	fputs($pp, "\t");
fputs($pp, "\t$S2\n\r");

/* sparo il foglio... ma guarda te se mi tocca usare il codice
   esadecimale di FF... */
fputs($pp, "\x0C");

/* chiudo la pipe... */
pclose($pp);

return(true);

}


/* e` una spudorata copia di quella sopra, con alcune informazioni
   aggiuntive da stampare... */
function LPRCucina($NO, $D, $TS, $IDV, $QTA, $NC, $Nomi, $T) {

global $nomep, $prezzop;
global $Titolo, $SottoTitolo, $LPRCommand;


/* calcolo l'ora dal timestamp... */
$TSc = $TS["C"];
$O = Date("H:i:s",$TSc);
$D = sprintf("%s/%s/%s", substr($D,8,2), substr($D,5,2), substr($D,2,2));

/* apriamo la pipe... */
$pp = popen($LPRCommand["V"], "w");
if ( $pp < 0 ) {
	return(-1);
}

/* uffi... devo fare i conti PRIMA di stampare le righe... */
$i = 0;
$tot = 0;
Reset($nomep);
while ($i < Count($nomep)) {
	$key = Key($nomep);
	/* tra i nomi dei piatti c'e` un nome falso, ``separatore'',
	   che serve... a forzare separazioni nell'output! */
	if ( ($nomep[$key] != "separatore") && ($QTA[$key] != "") ) {
		$tot = $tot + $QTA[$key]*$prezzop[$key];
	}
	$i++;
	Next($nomep);
}
$tots = ConvertiValuta($tot);

/* stringa che contiene numero d'ordine e data, e stringa che contiene
   ID e tempo di inserimento... se sono nulle, allora e` la stampa di
   un totale... */

if ( ($NO != "") && ($D != "") ) {
	$S1 = "$NO $D";
	$S2 = "($O $IDV)";
} else {
	$S1 = "";
	$S2 = "";
}

/* Stampo su una Canon BJ-200ex, devo per forza pasticciare con i
   comandi di stampa per ottenere un output decente... */

/* imposto e attivo l'interlinea a 2/8 di pollice, qualcosina in
   piu'... uffa, 18/72 e` poco e 19/72 e` troppo... ;((( */
$passo = 12;
fputs($pp, "\x1BA\x$passo");
fputs($pp, "\x1B2");
/* 'sta maledetta mi va in alta qualita`, imposto il font Bozza a 12
    CPI */
fputs($pp, "\x1BI\x0C");

/* salto tre righe e stampo il totale, allineato al margine di
   37 caratteri */
fputs($pp, "\n\r\n\r\n\r");
$j = 0;
while ( $j < (37 - strlen($tots)) ) {
	fputs($pp, " ");
	$j++;
}
fputs($pp, "$tots\n\r");

/* e poi, allineate a dx e sn rispettivamente,numero d'ordine e le
   informazioni per il cliente... */
fputs($pp, "$S1");
$j = 0;
while ( $j < (37 - strlen($S1) - strlen($S2)) ) {
	fputs($pp, " ");
	$j++;
}
fputs($pp, "$S2\n\r\n\r");

/* ristampo il numero d'ordine, questa volta all'inizio... ;))) */
fputs($pp, "$S1\n\r\n\r");


/* bene, sono pronto a stampare effettivamente l'ordine... */
$i = 0;
$sum = 0;
Reset($nomep);
while ($i < Count($nomep)) {
	$key = Key($nomep);
	/* tra i nomi dei piatti c'e` un nome falso, ``separatore'',
	   che serve... a forzare separazioni nell'output! */
	if ( $nomep[$key] == "separatore" ) {

		$j = 0;
		while ($j < ($prezzop[$key] - 2) ) {
			fputs($pp, "\n\r");
			$j++;
		}
		/* stampo le informazioni per il cliente... devo poi
		   allungare il passo, fare un \n e poi risettarlo... */
		fputs($pp, "   $S2");
		fputs($pp, "\x1BA\x0E");
		fputs($pp, "\x1B2");
		fputs($pp, "\n\r\n\r");
		fputs($pp, "\x1BA\x$passo");
		fputs($pp, "\x1B2");
	} else {
		if ($QTA[$key] == "") {
			fputs($pp, "\n\r");
		} else {
			$j = 0;
			while ( $j < (27 - strlen($QTA[$key])) ) {
				fputs($pp, " ");
				$j++;
			}
			fputs($pp, "$QTA[$key]");
			$sum = $QTA[$key]*$prezzop[$key];
			$sums = ConvertiValuta($sum);
			$j = 0;
			while ( $j < (10 - strlen($sums)) ) {
				fputs($pp,  " ");
				$j++;
			}
			fputs($pp, "$sums\n\r");
		}
	}
	/* ma guarda che porcate che mi tocca fare... */
	if ( ($i % 3) == 0 ) {
		if ($passo == 12) {
			$passo = 13;
		} else {
			$passo = 12;
		}
		fputs($pp, "\x1BA\x$passo");
		fputs($pp, "\x1B2");
		fputs($pp, "\x1BI\x0C");
	}
	$i++;
	Next($nomep);
}

/* scrivo l'ultima riga, numero d'ordine (ancora!) e totale... */
fputs($pp, "$S1");
$j = 0;
while ( $j < (37 - strlen($tots) - strlen($S1)) ) {
	fputs($pp, " ");
	$j++;
}
fputs($pp, "$tots\n\r");

/* e ora un po' di informazioni aggiuntive... */
if ( $NC != "" ) {
	fputs($pp, "\t$NC\n\r");
}
fputs($pp, "\t\t$S2\n\r");

/* bene, stampiamo quello che manca: */
fputs($pp, "\n\r\n\r");
$O = Date("H:i:s",$TS["C"]);
$Noc = $Nomi["C"];
fputs($pp, "Ordine inserito da $Noc\n\r");
fputs($pp, "\talle $O\n\r");
$Noc = $Nomi["A"];
if ( $Noc != "" ) {
	$Noc = $Nomi["A"];
	$O = Date("H:i:s",$TS["A"]);
	fputs($pp, "Ordine raccolto da $Noc\n\r");
	fputs($pp, "\talle $O al tavolo $T\n\r");
}
$O = Date("H:i:s",$TS["V"]);
$Noc = $Nomi["V"];
fputs($pp, "Ordine evaso da $Noc\n\r");
fputs($pp, "\talle $O\n\r");
fputs($pp, "\n\r");
fputs($pp, "La Pro Loco Cimpello ti ringrazia!\n\r");

/* sparo il foglio... ma guarda te se mi tocca usare il codice
   esadecimale di FF... */
fputs($pp, "\x0C");

/* chiudo la pipe... */
pclose($pp);

return(0);

}

/* FINE */?>